=======
HISTORY
=======

                  METADRAW .NET FOR WINFORMS
                     UPDATE HISTORY


The most recent build of MetaDraw .NET for Winforms is 1.2.19

 
IMPORTANT NOTES 

    = FOR USERS UPGRADING FROM PREVIOUS METADRAW.NET EDITIONS = 


1)  INSTALLATION - REPLACING OLD INSTALLATION

   If updating by use of new installation kit,
   the previous editions of MetaDraw .NET should 
   be uninstalled before installing a newer build 

   This is not required when updating using one of the
   Update kits ( available for upgrade from builds 1.2.4 or newer )


2)  UPDATING PROJECTS - DESIGN TIME SETTINGS

   As a rule Bennet-Tec strongly recommends NOT 
   setting MetaDraw picture properties at design time
   This includes the settings of the following properties
         Picture, PictureImage, BackPicture

   Because Visual Studio .NET stores the version number of the
   picture related properties as part of the resource, 
   an error can occur when trying to use a newer build of 
   MetaDraw to run or compile an old project where these 
   have been set at design time.    
   When updating to a new build of MetaDraw .Net, 
   projects which had such design-time assignments for MetaDraw 
   pictures must be manually updated - to remove any previously 
   assigned MetaDraw Picture from the project resource file 
   The picture may then be reassigned as a new design time 
   property setting but again we recommend setting picture 
   properties only with run-time code. ( for instance initializing
   these properties in a form load event ).

   Rather than set picture properties at design time
   if the programmer wishes to store images using a resource
   file the recommended approach is 
      a) Add image to the solution 
      b) property window for this image set 
         the "Type" or "build action" to "Embedded Resource"
      b) In Form_Load event ( or any other event ) you can 
         then set the desired MetaDraw picture property
         with this image from the resource file.
         for example: 
              Dim s As System.IO.Stream =
                   Me.GetType().Module.Assembly
                  .GetManifestResourceStream("Create.Image.WMF")
               MetaDraw1.LoadPicture(s, PictureSource.PictureImage)

--------------------------------------------
MetaDraw 1.2.19.0 build from	Feb 09, 2009
--------------------------------------------

FIXED	Zooming backpicture		(SP#13467, 14131 )

	The Background picture was not zoomed together with
	main picture when PictureFlags.PicBackground was set.


--------------------------------------------
MetaDraw 1.2.16.0 build from	Aug 31, 2006
--------------------------------------------

ENHANCEMENT	PERFORMANCE

	It now takes significantly less time to 
	update a MetaDraw picture which contains 
	a very large paletted bitmap 

FIXED	Undo error when deleting empty text	(SP#10586)

	When a new text object was created by mouse 
	and the creation was cancelled ( by Esc key )
	then the next Undo operation caused a run-time error

FIXED	Undo on Moving rotated objects	(SP#10389)

	Rotated objects were distorted after Move/Undo operations

FIXED	Exporting single rotated object	(SP#10389)

	After When exporting a single rotated object 
	and reinserting back to MetaDraw,
	the object size was distorted
	
FIXED	Printing multiple copies		(SP#10154)

	MetaDraw printed too many copies of an image
	( the square of the specified number of copies
	specified in print dialog ) 
	when printing to selected printer (ExportDC = -2)


--------------------------------------------
MetaDraw 1.2.15.0 build 	May 03, 2006
--------------------------------------------

PERFORMANCE ENHANCEMENT 	
	Loading large raster images with pallete
	causing an update of the palette in MetaDraw for large image 
	previously was slow - the speed for handling such images 
	has been significantly improved.

FIXED	Group exporting		(SP#10042)
	When a group object was exported as selected object
	its boundaries were calculated incorrectly.

FIXED	Object editing		(SP#9545)
	Objects marked as Invisible could be selected by end-user mouse 
	action even when PICOPT_HIDEINVISIBLE flag is set
	and the object was truly invisible

FIXED	Custom Cursor		(SP#9149)
	User cursor could not be set when ED_ZOOM edit mode
	is active.

CHANGE	Zoom cursors
	The default shapes for ZoomIn and ZoomOut cursors have changed


--------------------------------------------
MetaDraw 1.2.14.0 build 	Mar 26, 2006
--------------------------------------------
Internal build

--------------------------------------------
MetaDraw 1.2.13.0 build 	Jan 16, 2006
--------------------------------------------
FIXED	Copy/Paste control	(SP# 9398)
	Copy MetaDraw .NET control to the clipboard
	and paste in back to the form did not work.
	
FIXED	MDR file backward compatibility
	Now the MDR file is backward compatible.
	This means that build 1.2.13 can read MDR file created by all 
	the previous version of MetaDraw .NET.

--------------------------------------------
MetaDraw 1.2.12.0 build from	Aug 12, 2005
--------------------------------------------

ENHANCEMENT   Gradient FillStyle	(SP# 8472)
	Gradient FillStyle now supports setting 
                      of BackColor or FillColor using a "system" color
                  Previously the actual color itself had to be specified.

FIXED   Transparent bitmap	(SP# 8474)
	Transparent bitmaps looked distorted if 
	if Zoomfactor was set  less than  1.

FIXED   ScaleUnits property 		(ID# 692, SP# 8223)
	The setting of the ScaleUnits property was not properly preserved 
	after saving and loading with SaveData / LoadData methods

--------------------------------------------
MetaDraw 1.2.11.0 build      	June 7 , 2005
--------------------------------------------

FIXED	Transparent GIF		(ID# 624)
	Processing of GIF files with transparent colors  
	has been improved.
	
FIXED	Grouped Text objects	(SP# 7825, SP# 7648)
	After saving and reloading MetaDraw picture (MDP-format), 
	the position and Size of the text objects might be changed. 

--------------------------------------------
MetaDraw 1.2.10.0 build 	May 17, 2005
--------------------------------------------

FIXED	CreateLink method	(SP# 7937)

	Creating a link using the CreateLink method in code 
	produced an error.
	( error introduced in build 1.2.7 is corrected here )  

FIXED	CreateImageMap method	(ID# 676 / SP# 7850)
	The ImageMap coordinates produced by the CreateImageMap 
	method were incorrectly presented in hexadecimal format. 
	Now coordinates are correctly presented as decimal numeric values.

--------------------------------------------
MetaDraw 1.2.9.0 build      	Apr 26, 2005
--------------------------------------------

ENHANCEMENT	Selection behavior  (SP# 7440)

	Added additional control over mouse based selection behavior.

                  A new EditFlags property flag bit is now supported. 
	When flag bit  EFLG_SELSHIFTEX   is set, 
                    clicking an already selected object will not deselect the object.

	(This flag is ignored if EFLG_SELSHIFT flag is set)

	    ( This feature requires Subscription License Option ) 


FIXED	FloodFill object	(ID# 665)

	The OT_FloodFill object did not work properly 
	when grouped within a container with other elements.

--------------------------------------------
MetaDraw 1.2.8.0 build      	Mar 01, 2005
--------------------------------------------

ENHANCEMENT	Shadows for PolyBezier & PolyPolygon objects (ID# 656 / SP# 7369)

	Object Shadows - ( ObjShadow property) are now supported 
	for PolyBezier & PolyPolygon objects

FIXED	Editing mode - use in Change Event  (ID# 657)

	Changing the EditMode ( eg to ED_VIEW ) within the Change event
	while an object was being modified ( eg resized or moved )
	caused MetaDraw to crash

	( Note - is is strongly recommended that the state 
	  of MetaDraw  should NOT be changed within Change event.
	  However it is now safer to do so )

FIXED	ObjType property		(ID#653)

	Converting an OT_Rect, OT_RoundRect, or OT_Ellipse
	to Polyline incorrectly added arrow terminators 

--------------------------------------------
MetaDraw 1.2.7.0 build      	Jan 12, 2005
--------------------------------------------

ENHANCEMENT	UnDo / ReDo  (ID# 552)

	Two new properties were added 

	- UnDoAvailable - returns number of available ReDo steps

	- ReDoAvailable - returns number of available ReDo steps

	Setting these properties, reduces the number of available 
	UnDo / ReDo steps available (older actions will be discarded).
	Setting to 0 deletes all Undo (or Redo) actions from the stack

ENHANCEMENT	New - Replacing objects - ObjPicture property	(ID#531)

	A new property, ObjPicture, was added. 

	When read, this property returns a picture created on object(s) specified 
	by the .Current property (exactly like the .PictureClip property).

	When set, ObjPicture, replaces object(s) specified by 
	the .Current property with the assigned picture  
	without modifying ObjTags, ObjNumber,
	or associated links for the replaced drawing element.

FIXED    LoadData method		(ID# 652)

	The LoadData method did not work correctly for links objects
	(links were broken after calling SaveData and then LoadData).

--------------------------------------------
MetaDraw 1.2.6.0 build      	Dec 03, 2004
--------------------------------------------

( New Install Kit )
	
ENHANCEMENT Undo/Redo for SendBack/MoveFront  (SP# 7035,5841)  (D580 )

	Undo and redo are now supported for SendBack/MoveFront actions.

FIXED	DXF loadpicture	(SP# 7015)

	Some DXF layers were not preserved when loading DXF file.
	   ( Note - DXF file format is only supported for users
	     with DXF support license ) 

FIXED	LoadPicture method	( No ID)

	Calling the LoadPicture method with Image object as first
	parameter caused disposing of that image so that it could
	not be used elsewhere

FIXED	Getting UnDo/ReDo levels	(SP# 7035)

	Retreiving UnDo/ReDo actions count caused modification 
	of current MetaDraw state.
	
--------------------------------------------
MetaDraw 1.2.5.0 build      	Sep 07, 2004
--------------------------------------------
(Patch file MDN_P-05.ZIP)


FIXED	Application crash on exit	(SP#6732,  6766 ) 
	An Error occured when closing and reopening a MetaDraw based form
	(without disposing it).

	The same error could occur when toggling visible property 
	of parent MDI Child form  

	It seems that .NET framework directly kills a thread 
	that contains some GDI object before object destructor 
	called in another thread (and uses these CGI) is finished.  
	Additional checks have been added that eliminate this problem.

FIXED	PolyBezier object		(SP#6684)

	Mouse click on a PolyBezier object with only 3 points
	sometimes caused heap distortion.

--------------------------------------------
MetaDraw 1.2.4.0 build      	Aug 30, 2004
--------------------------------------------

INSTALL KIT - a new installation kit is released

SAMPLES - sample projects were updated 
	to avoid possible confusing use of design time 
	settings of picture properties

FIXED   Dependencies
	Build 1.2.3 was accidentally created using debug versions of Microsoft DLLs
	creating problems in distribution of application.   This has been corrected.

FIXED	BMP loading		(SP# 6686)
	Reading bitmaps (either from BMP or WMF files) sometimes caused error.

FIXED	WMF loading		(SP# 6686)
	There was an error when reading Metafiles ( .WMF ) 
	which contained UNICODE tag strings.

FIXED	License compatibility		()
	There was a license problem causing difficulties in updating
	from older builds to 1.2.1, 1.2.2, or 1.2.3
	Projects that used MetaDraw .NET version 1.0.x & 1.1.x 
	can be now compiled with newer version of MetaDraw component.

FIXED	Application crash on exit		()
	There was a serious error in build 1.2.3 causing
	MetaDraw based VB.NET applications to crash when 
	stopped with the VB 'End' statement.


--------------------------------------------
MetaDraw 1.2.3.0 build      	July 16, 2004
--------------------------------------------

    = WARNING !!=      
	The 1.2.3 build is an INTERNAL BENNET-TEC BUILD
	This should be not be released - it was incorrectly built 
	using Debug libraries and also with lack of binary compatibility 
	It will introduce signifant problems

ENHANCEMENT	GetParams/SetParams for PolyPolygon	(ID#620 / SP#6455)

	MetaDraw now supports changing parameters of PolyPolygon 
	objects using the GetParams/SetParams methods.

FIXED	ChangeLogicalCoords method		(ID#612 / SP# 6289)
	Additional fix.

--------------------------------------------
MetaDraw 1.2.2.0 build      	June 10, 2004
--------------------------------------------

FIXED	ObjRotation for Link object	(ID#614)

	When a link object was too short (several pixels),
	the ObjRotation property returned incorrect angle for link line.

FIXED	LinkObject property

	It was not possible to set start & end of a link object 
	to point at the same object even if EFLG_FREELINK flag is set.

FIXED	Undo for SetParams	(ID#580 / SP# 5841)

	Undo was not able to undo effect of SetParams method.

FIXED	Ungrouping containers	(SP# 6331)

	Text objects shrunk when container was ungrouped.

FIXED	ChangeLogicalCoords method		(ID#612 / SP# 6289)

	Calling the ChangeLogicalCoords method caused errors if 
	the change reduced the picture dimensions and caused a linked
	object to then be outside bounds of new picture 

--------------------------------------------
MetaDraw 1.2.1.2 build 
--------------------------------------------

FIXED     ScaleUnits property	( SP# 6258 )

	 Conversion worked incorrectly for scaleunits other than Pixels & Twips 

	 This bug was previously fixed in build 1.1 
	 but then lost in 1.2.1 so it was corrected again in 1.2.1.2

FIXED     Selection of Dimension Lines    ( SP# 5519 / Dev 562 )

	 DimLine objects drawn from right to left couldn't 
	 be selected with the mouse rectangle.

--------------------------------------------
MetaDraw 1.2.1.0 build      	May 20 , 2004
--------------------------------------------

ENHANCEMENT   UNICODE SUPPORT ADDED 

	    **** COMPATIBILITY NOTE  ***

	     This new update is backward compatible with older
	     MetaDraw .NET builds.    

	     Older builds of MetaDraw can not however read 
	     MDR and MDP files created by the new build
	     and old builds will not be able to read the 
	     objTag, ObjTags and ObjURL properties after
	     loading a WMF or EMF file created by new build

FIXED     KeyDown event             - 6254 -  

	 The KeyDown event didn't trap Arrow Keys

FIXED     Change Event             - 6200 -  / dev 607

	 The .Current property incorrectly returned a value of OBJ_NULL 
	 when read within the Change Event if the event was triggered
	as a result of a link being drawn with the mouse in ED_Link mode
	The correct value ( pointing to the link object ) is now returned.

FIXED     Memory Leak               - DEV 5948 - 591

	There were Memory Leaks when certain properties were used 
	within a VC++.NET application

--------------------------------------------
MetaDraw 1.1.1.0 build      	May 04, 2004
--------------------------------------------

ENHANCEMENT		- New Edit Mode for Links   (ID# 551 / SP# 5414)

	A New edit mode ED_LINKPOLY was added. 
	In this edit mode, links drawn by the user are, by default, segmented 
	( rather than single line straight links of ED_Link mode) . 

	It is possible to switch between segmented or straight links
	using the ALT key in either ED_Link or ED_LinkPoly modes.

ENNHANCEMENT		- New EditFlag for editing Links  (ID# 551 / SP# 5414)

	A New edit flag value EFLG_AUTOLINK is now supported. 

	When it set (default) link connection points in LINK edit modes 
	will be automatically calculated. 

	When dropped ( not set ) connection points will be set according 
	to current mouse position (this behavior can be switched by pressing 
	the SHIFT key).


ENHANCEMENT		- New change mode event   (ID# 547 / SP# 5359)

	A New change event trigger was added - 
	                    BTIS.MetaDraw.ChangeType.Completed
	The change event is now triggered with this parameter
	after an object has been completely added by the mouse.

	Note that this occurs after the ChangeEvent has been previously
	triggered with parmaeter BTIS.MetaDraw.ChangeType.Added 
	indicating the start of drawing a new object

  	When triggered the value of .Current contains handle of new object.

ENHANCEMENT	New - Replacing objects - ObjPicture property	(ID#531)

	A new property, ObjPicture, was added. 

	This property allows replacement of a single element of the 
	drawing while maintaining the layering order, tags, and links

	When read, this property returns a picture created on object(s) specified 
	by the .Current property (exactly like the .PictureClip property).

	When set, ObjPicture, replaces object(s) specified by 
	the .Current property with the assigned picture  
	without modifying ObjTags, ObjNumber,
	or associated links for the replaced drawing element.

ENHANCEMENT 	Support for PolyPolygons	( SP 5127, D 520 )

	MetaDraw can now load WMF files containing PolyPolygons

FIXED	Resource leak when running in Demonstration mode ()

	There was a resource leak associated with presentation 
	of DEMO message when running in demonstration mode
	( prior to registration of a license )

FIXED	ObjectsHitTest method (ID# 554 / SP# 5445)

	ObjectsHitTest did not perform correctly when 
	FND_CURRENT & FND_RECURSE flags were specified together.

FIXED	Loading MDP files with Multi-Segment Links  (ID# 554 / SP# 5445)

	If a MetaDraw MDP file contained an image with a 
	Multi-segment link then loading caused an error

FIXED	Undo  / Rotate				(ID#528 SP#5196)

	Undo did not work for objects rotated by user in ED_ROTATE edit mode
	or by the RotateObjects method.

FIXED	Undo / Font Name				(ID#525 SP#5153)

	Undo did not work with FontName.

FIXED	Gradients / DrawMode		(ID#502 SP#4963)

	Gradients were choppy when drawn using 
	          FillStyle = FS_GRADIENT 
	and DrawMode = R2_MERGENOTPEN

Fixed	Resizing Grouped Text Objects	 ( SP 5128, D 521 )

	Resizing a container (group) holding a text object,
	incorrectly caused the text object to change position.

--------------------------------------------
MetaDraw 1.0.0.4 build      	12 February 2004
--------------------------------------------

Fixed	DXF - Dimension Lines    (ID#492 SP#4878)

	 DimLines were not correctly exported to DXF 
	when the PICOPT_DXFVERSION14 flag was set 
	in PictureOptions (Arrow heads were closed). 

	   ( Note - DXF file format is only supported for users
	     with DXF support license ) 


--------------------------------------------
MetaDraw 1.0.0.3 build      	Jul 25, 2003
--------------------------------------------

ENHANCEMENT     Zooming       (ID#459)

	A new property, ZoomFactor, was added.
	Setting the ZoomFactor property visually 
	zooms or shrinks the image to the desired multiple 
	of the OrigWidth and OrigHeigth settings
	( PicXSize, PicYSize, and AutoScale are automatically
	reset by setting ZoomFactore property )

FIXED   Arrow Heads (ID#474 SP#4612)

	Arrow heads incorrectly appeared on standard 
	lines when reloading .MDP file.
  
FIXED	(ID#481 SP#4603)

	DblClick did not open properly objects for editing.


--------------------------------------------
MetaDraw 1.0.0.2 Formal Release	Jul 07, 2003
--------------------------------------------
